<div class="command">
    <div *ngIf="expand; else noExpand">
        <button mat-icon-button (click)="expand = false">
            <mat-icon>expand_more</mat-icon>
        </button>
    </div>
    <ng-template #noExpand>
        <button mat-icon-button (click)="expand = true">
            <mat-icon>chevron_right</mat-icon>
        </button>
    </ng-template>
    <div class="content">
        <div class="header">
            <div class="command-name" *ngIf="command.observable === false, else observable">{{ command.identifier }}</div>
            <ng-template #observable>
                <div class="command-name">[observable] {{ command.identifier }}</div>
            </ng-template>
            <div class="command-description">{{ command.description }}</div>
        </div>

        <div class="border" *ngIf="expand">
            <div class="section-title">Parameters</div>
            <div class="section-content">
                <div
                    class="param-border"
                    *ngFor="let param of command.parameters; index as i"
                >
                    <div class="params">
                        <div>
                            <div>
                                <span class="param-name"
                                               title="{{
                                    param.data_type.type
                                }}  ">{{
                                             param.identifier
                                             }}</span>
                            </div>
                            <div class="param-desc">
                                {{ param.description }}
                            </div>
                        </div>
                        <div>
                            <mat-form-field class="value-field">
                                <mat-label>Set value</mat-label>
                                <input
                                    matInput
                                    [(ngModel)]="paramValues[i]"
                                />

                            </mat-form-field>
                        </div>
                    </div>
                </div>
                <mat-form-field class="input-json">
                    <textarea
                        placeholder="POST JSON"
                        matInput
                        matTextareaAutosize
                        matAutosizeMinRows=3
                        matAutosizeMaxRows=10
                        disabled
                        [(ngModel)]= "inputJSON"
                    >
                    </textarea>

                </mat-form-field>
            </div>
            <div class="section-content">
              <div *ngIf="command.observable === true">
                  <div class="section-title">Intermediate Responses</div>
                  <div
                    class="param-border"
                    *ngFor="let response of command.intermediate_responses index as k"
                >
                    <div class="params">
                        <div>
                            <div>
                                <mat-checkbox class="param-response-select" [(ngModel)]=intermediateSelected[k] [disabled]="this.intermediateSelected.length === 1" color="primary"> </mat-checkbox>
                                <span class="param-name"
                                      title="{{
                                    response.data_type.type
                                }}  ">{{
                                    response.identifier
                                    }}</span>
                            </div>
                            <div class="param-desc">
                                {{ response.description }}
                            </div>
                        </div>
                        <div>
                            <mat-form-field class="value-field">
                                <mat-label>Return value</mat-label>
                                <input
                                    matInput
                                    disabled
                                    type="text"
                                    placeholder="Return value"
                                    value="{{this.intermediateValues[k]}}"
                                />
                            </mat-form-field>
                        </div>
                    </div>
                </div>
              </div>
                <div class="section-title">Responses</div>
                <div
                    class="param-border"
                    *ngFor="let response of command.responses index as j"
                >
                    <div class="params">
                        <div>
                            <div>
                                <mat-checkbox class="param-response-select" [(ngModel)]=selected[j] color="primary" [disabled]="this.selected.length === 1"> </mat-checkbox>
                                <span class="param-name"
                                title="{{
                                    response.data_type.type
                                }}  ">{{
                                    response.identifier
                                }}</span>
                            </div>
                            <div class="param-desc">
                                {{ response.description }}
                            </div>
                        </div>
                        <div>
                            <mat-form-field class="value-field">
                                <mat-label>Return value</mat-label>
                                <input
                                    matInput
                                    disabled
                                    type="text"
                                    placeholder="Return value"
                                    value="{{this.returnValues[j]}}"
                                />
                            </mat-form-field>
                        </div>
                    </div>
                </div>
            </div>
            <!-- <div class="section-title">Usage</div>
                 <div class="section-content example-code">
                       <code>
                           response =
                           <span class="python-object">yourObject</span>.<span
                               class="python-function"
                               >call_command</span
                           >(<span class="python-string"
                               >"{{ featureIdentifier }}"</span
                           >,<span class="python-string"
                               >"{{ command.identifier }}"</span
                           >,parameters: {{ '{' }}

                           <ng-container
                               *ngFor="
                                   let param of command.parameters;
                                   index as i;
                                   let last = last
                               "
                           >
                               <span class="python-string"
                                   >"{{ param.identifier }}/{{ param.data_type }}"</span
                               >:
                               <ng-container
                                   *ngIf="param.data_type === 'String' || param.data_type === 'constrained/String' ; else noString"
                               >

                                   <span class="python-string">
                                       "{{ paramValues[i].value }}"
                                   </span>

                               </ng-container>

                               <ng-template #noString>
                                   {{ paramValues[i].value }}
                               </ng-template>
                               <ng-container *ngIf="!last">, </ng-container>
                           </ng-container>
                           {{ '}' }})
                       </code>

                   </div> -->
            <div>
                <div *ngIf="command.observable === false, else observable">
                    <button
                        mat-flat-button
                        color="primary"
                        aria-label="Run"
                        (click)="callCommand(command.identifier)"
                    >
                        Run
                    </button>
                </div>
                <ng-template #observable>
                        <button
                                class = "right-button"
                                mat-flat-button
                                color="primary"
                                aria-label="Run new"
                                (click)="startObservable(command.identifier)"
                            >
                            Run new
                        </button>
                    <button
                        mat-flat-button
                        color="primary"
                        aria-label="Cancel"
                        [disabled]="!observableRunning"
                        (click)="stopObservable(command.identifier)"
                    >
                        Cancel
                    </button>
                    </ng-template>
            </div>
        </div>
    </div>
</div>
